Index: CKEditor/trunk/_source/plugins/dialog/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/dialog/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/dialog/plugin.js	(revision 6241)
@@ -106,8 +106,17 @@
 	{
 		// Load the dialog definition.
-		var definition = CKEDITOR.dialog._.dialogDefinitions[ dialogName ];
+		var definition = CKEDITOR.dialog._.dialogDefinitions[ dialogName ],
+			defaultDefinition = CKEDITOR.tools.clone( defaultDialogDefinition ),
+			buttonsOrder = editor.config.dialog_buttonsOrder || 'OS',
+			dir = editor.lang.dir;
+
+			if ( ( buttonsOrder == 'OS' && CKEDITOR.env.mac ) ||    // The buttons in MacOS Apps are in reverse order (#4750)
+				( buttonsOrder == 'rtl' && dir == 'ltr' ) ||
+				( buttonsOrder == 'ltr' && dir == 'rtl' ) )
+					defaultDefinition.buttons.reverse();
+
 
 		// Completes the definition with the default values.
-		definition = CKEDITOR.tools.extend( definition( editor ), defaultDialogDefinition );
+		definition = CKEDITOR.tools.extend( definition( editor ), defaultDefinition );
 
 		// Clone a functionally independent copy for this dialog.
@@ -117,5 +126,4 @@
 		// functions.
 		definition = new definitionObject( this, definition );
-
 
 		var doc = CKEDITOR.document;
@@ -131,5 +139,4 @@
 			contentSize : { width : 0, height : 0 },
 			size : { width : 0, height : 0 },
-			updateSize : false,
 			contents : {},
 			buttons : {},
@@ -180,4 +187,32 @@
 			}
 			, editor ).definition;
+
+		var tabsToRemove = {};
+		// Cache tabs that should be removed.
+		if ( !( 'removeDialogTabs' in editor._ ) && editor.config.removeDialogTabs )
+		{
+			var removeContents = editor.config.removeDialogTabs.split( ';' );
+
+			for ( i = 0; i < removeContents.length; i++ )
+			{
+				var parts = removeContents[ i ].split( ':' );
+				if ( parts.length == 2 )
+				{
+					var removeDialogName = parts[ 0 ];
+					if ( !tabsToRemove[ removeDialogName ] )
+						tabsToRemove[ removeDialogName ] = [];
+					tabsToRemove[ removeDialogName ].push( parts[ 1 ] );
+				}
+			}
+			editor._.removeDialogTabs = tabsToRemove;
+		}
+
+		// Remove tabs of this dialog.
+		if ( editor._.removeDialogTabs && ( tabsToRemove = editor._.removeDialogTabs[ dialogName ] ) )
+		{
+			for ( i = 0; i < tabsToRemove.length; i++ )
+				definition.removeContents( tabsToRemove[ i ] );
+		}
+
 		// Initialize load, show, hide, ok and cancel events.
 		if ( definition.onLoad )
@@ -602,5 +637,4 @@
 
 				this._.contentSize = { width : width, height : height };
-				this._.updateSize = true;
 			};
 		})(),
@@ -614,13 +648,6 @@
 		getSize : function()
 		{
-			if ( !this._.updateSize )
-				return this._.size;
 			var element = this._.element.getFirst();
-			var size = this._.size = { width : element.$.offsetWidth || 0, height : element.$.offsetHeight || 0};
-
-			// If either the offsetWidth or offsetHeight is 0, the element isn't visible.
-			this._.updateSize = !size.width || !size.height;
-
-			return size;
+			return { width : element.$.offsetWidth || 0, height : element.$.offsetHeight || 0};
 		},
 
@@ -630,4 +657,5 @@
 		 * @param {Number} x The target x-coordinate.
 		 * @param {Number} y The target y-coordinate.
+		 * @param {Boolean} save Flag indicate whether the dialog position should be remembered on next open up.
 		 * @example
 		 * dialogObj.move( 10, 40 );
@@ -636,5 +664,5 @@
 		{
 			var isFixed;
-			return function( x, y )
+			return function( x, y, save )
 			{
 				// The dialog may be fixed positioned or absolute positioned. Ask the
@@ -663,4 +691,6 @@
 							'top'	: ( y > 0 ? y : 0 ) + 'px'
 						});
+
+				save && ( this._.moved = 1 );
 			};
 		})(),
@@ -709,5 +739,6 @@
 
 			// First, set the dialog to an appropriate size.
-			this.resize( definition.minWidth, definition.minHeight );
+			this.resize( this._.contentSize && this._.contentSize.width || definition.minWidth,
+					this._.contentSize && this._.contentSize.height || definition.minHeight );
 
 			// Reset all inputs back to their default value.
@@ -754,18 +785,13 @@
 			this._.hasFocus = false;
 
-			// Rearrange the dialog to the middle of the window.
 			CKEDITOR.tools.setTimeout( function()
 				{
-					var viewSize = CKEDITOR.document.getWindow().getViewPaneSize();
-					var dialogSize = this.getSize();
-
-					// We're using definition size for initial position because of
-					// offten corrupted data in offsetWidth at this point. (#4084)
-					this.move( ( viewSize.width - definition.minWidth ) / 2, ( viewSize.height - dialogSize.height ) / 2 );
-
+					this.layout();
 					this.parts.dialog.setStyle( 'visibility', '' );
 
 					// Execute onLoad for the first show.
 					this.fireOnce( 'load', {} );
+					CKEDITOR.ui.fire( 'ready', this );
+
 					this.fire( 'show', {} );
 					this._.editor.fire( 'dialogShow', this );
@@ -776,4 +802,17 @@
 				},
 				100, this );
+		},
+
+		/**
+		 * Rearrange the dialog to its previous position or the middle of the window.
+		 * @since 3.5
+		 */
+		layout : function()
+		{
+			var viewSize = CKEDITOR.document.getWindow().getViewPaneSize(),
+					dialogSize = this.getSize();
+
+			this.move( this._.moved ? this._.position.x : ( viewSize.width - dialogSize.width ) / 2,
+					this._.moved ? this._.position.y : ( viewSize.height - dialogSize.height ) / 2 );
 		},
 
@@ -904,5 +943,5 @@
 							expand : !!contents.expand,
 							padding : contents.padding,
-							style : contents.style || 'width: 100%; height: 100%;'
+							style : contents.style || 'width: 100%;'
 						}, pageHtml );
 
@@ -1343,7 +1382,4 @@
 	};
 
-	// The buttons in MacOS Apps are in reverse order #4750
-	CKEDITOR.env.mac && defaultDialogDefinition.buttons.reverse();
-
 	// Tool function used to return an item from an array based on its id
 	// property.
@@ -1614,5 +1650,5 @@
 				realX = - margins[3];
 			else if ( abstractDialogCoords.x - margins[1] > viewPaneSize.width - dialogSize.width - magnetDistance )
-				realX = viewPaneSize.width - dialogSize.width + margins[1];
+				realX = viewPaneSize.width - dialogSize.width + ( editor.lang.dir == 'rtl' ? 0 : margins[1] );
 			else
 				realX = abstractDialogCoords.x;
@@ -1625,5 +1661,5 @@
 				realY = abstractDialogCoords.y;
 
-			dialog.move( realX, realY );
+			dialog.move( realX, realY, 1 );
 
 			evt.data.preventDefault();
@@ -1645,6 +1681,4 @@
 		dialog.parts.title.on( 'mousedown', function( evt )
 			{
-				dialog._.updateSize = true;
-
 				lastCoords = { x : evt.data.$.screenX, y : evt.data.$.screenY };
 
@@ -1666,116 +1700,104 @@
 	function initResizeHandles( dialog )
 	{
-		var definition = dialog.definition,
-			minWidth = definition.minWidth || 0,
-			minHeight = definition.minHeight || 0,
-			resizable = definition.resizable,
-			margins = dialog.getParentEditor().skin.margins || [ 0, 0, 0, 0 ];
-
-		function topSizer( coords, dy )
-		{
-			coords.y += dy;
-		}
-
-		function rightSizer( coords, dx )
-		{
-			coords.x2 += dx;
-		}
-
-		function bottomSizer( coords, dy )
-		{
-			coords.y2 += dy;
-		}
-
-		function leftSizer( coords, dx )
-		{
-			coords.x += dx;
-		}
-
-		var lastCoords = null,
-			abstractDialogCoords = null,
-			magnetDistance = dialog._.editor.config.magnetDistance,
-			parts = [ 'tl', 't', 'tr', 'l', 'r', 'bl', 'b', 'br' ];
-
-		function mouseDownHandler( evt )
-		{
-			var partName = evt.listenerData.part, size = dialog.getSize();
-			abstractDialogCoords = dialog.getPosition();
-			CKEDITOR.tools.extend( abstractDialogCoords,
-				{
-					x2 : abstractDialogCoords.x + size.width,
-					y2 : abstractDialogCoords.y + size.height
-				} );
-			lastCoords = { x : evt.data.$.screenX, y : evt.data.$.screenY };
-
-			CKEDITOR.document.on( 'mousemove', mouseMoveHandler, dialog, { part : partName } );
-			CKEDITOR.document.on( 'mouseup', mouseUpHandler, dialog, { part : partName } );
+		var def = dialog.definition,
+			resizable = def.resizable;
+
+		if ( resizable == CKEDITOR.DIALOG_RESIZE_NONE )
+			return;
+
+		var editor = dialog.getParentEditor();
+		var wrapperWidth, wrapperHeight, viewSize, origin, startSize;
+
+		function positionDialog( right )
+		{
+			// Maintain righthand sizing in RTL.
+			if ( dialog._.moved && editor.lang.dir == 'rtl' )
+			{
+				var element = dialog._.element.getFirst();
+				element.setStyle( 'right', right + "px" );
+				element.removeStyle( 'left' );
+			}
+			else if ( !dialog._.moved )
+				dialog.layout();
+		}
+
+		var mouseDownFn = CKEDITOR.tools.addFunction( function( $event )
+		{
+			startSize = dialog.getSize();
+
+			// Calculate the offset between content and chrome size.
+			wrapperHeight = startSize.height - dialog.parts.contents.getSize( 'height',  ! ( CKEDITOR.env.gecko || CKEDITOR.env.opera || CKEDITOR.env.ie && CKEDITOR.env.quirks ) );
+			wrapperWidth = startSize.width - dialog.parts.contents.getSize( 'width', 1 );
+
+			origin = { x : $event.screenX, y : $event.screenY };
+
+			viewSize = CKEDITOR.document.getWindow().getViewPaneSize();
+
+			CKEDITOR.document.on( 'mousemove', mouseMoveHandler );
+			CKEDITOR.document.on( 'mouseup', mouseUpHandler );
 
 			if ( CKEDITOR.env.ie6Compat )
 			{
 				var coverDoc = currentCover.getChild( 0 ).getFrameDocument();
-				coverDoc.on( 'mousemove', mouseMoveHandler, dialog, { part : partName } );
-				coverDoc.on( 'mouseup', mouseUpHandler, dialog, { part : partName } );
-			}
+				coverDoc.on( 'mousemove', mouseMoveHandler );
+				coverDoc.on( 'mouseup', mouseUpHandler );
+			}
+
+			$event.preventDefault && $event.preventDefault();
+		});
+
+		// Prepend the grip to the dialog.
+		dialog.on( 'load', function()
+		{
+			var direction = '';
+			if ( resizable == CKEDITOR.DIALOG_RESIZE_WIDTH )
+				direction = ' cke_resizer_horizontal';
+			else if ( resizable == CKEDITOR.DIALOG_RESIZE_HEIGHT )
+				direction = ' cke_resizer_vertical';
+			var resizer = CKEDITOR.dom.element.createFromHtml( '<div class="cke_resizer' + direction + '"' +
+					' title="' + CKEDITOR.tools.htmlEncode( editor.lang.resize ) + '"' +
+					' onmousedown="CKEDITOR.tools.callFunction(' + mouseDownFn + ', event )"></div>' );
+			dialog.parts.footer.append( resizer, 1 );
+		});
+		editor.on( 'destroy', function() { CKEDITOR.tools.removeFunction( mouseDownFn ); } );
+
+		function mouseMoveHandler( evt )
+		{
+			var rtl = editor.lang.dir == 'rtl',
+				dx = ( evt.data.$.screenX - origin.x ) * ( rtl ? -1 : 1 ),
+				dy = evt.data.$.screenY - origin.y,
+				width = startSize.width,
+				height = startSize.height,
+				internalWidth = width + dx * ( dialog._.moved ? 1 : 2 ),
+				internalHeight = height + dy * ( dialog._.moved ? 1 : 2 ),
+				element = dialog._.element.getFirst(),
+				right = rtl && element.getComputedStyle( 'right' ),
+				position = dialog.getPosition();
+
+			// IE might return "auto", we need exact position.
+			if ( right )
+				right = right == 'auto' ? viewSize.width - ( position.x || 0 ) - element.getSize( 'width' ) : parseInt( right, 10 );
+
+			if ( position.y + internalHeight > viewSize.height )
+				internalHeight = viewSize.height - position.y;
+
+			if ( ( rtl ? right : position.x ) + internalWidth > viewSize.width )
+				internalWidth = viewSize.width - ( rtl ? right : position.x );
+
+			// Make sure the dialog will not be resized to the wrong side when it's in the leftmost position for RTL.
+			if ( ( resizable == CKEDITOR.DIALOG_RESIZE_WIDTH || resizable == CKEDITOR.DIALOG_RESIZE_BOTH ) && !( rtl && dx > 0 && !position.x ) )
+				width = Math.max( def.minWidth || 0, internalWidth - wrapperWidth );
+
+			if ( resizable == CKEDITOR.DIALOG_RESIZE_HEIGHT || resizable == CKEDITOR.DIALOG_RESIZE_BOTH )
+				height = Math.max( def.minHeight || 0, internalHeight - wrapperHeight );
+
+			dialog.resize( width, height );
+			// The right property might get broken during resizing, so computing it before the resizing.
+			positionDialog( right );
 
 			evt.data.preventDefault();
 		}
 
-		function mouseMoveHandler( evt )
-		{
-			var x = evt.data.$.screenX,
-				y = evt.data.$.screenY,
-				dx = x - lastCoords.x,
-				dy = y - lastCoords.y,
-				viewPaneSize = CKEDITOR.document.getWindow().getViewPaneSize(),
-				partName = evt.listenerData.part;
-
-			if ( partName.search( 't' ) != -1 )
-				topSizer( abstractDialogCoords, dy );
-			if ( partName.search( 'l' ) != -1 )
-				leftSizer( abstractDialogCoords, dx );
-			if ( partName.search( 'b' ) != -1 )
-				bottomSizer( abstractDialogCoords, dy );
-			if ( partName.search( 'r' ) != -1 )
-				rightSizer( abstractDialogCoords, dx );
-
-			lastCoords = { x : x, y : y };
-
-			var realX, realY, realX2, realY2;
-
-			if ( abstractDialogCoords.x + margins[3] < magnetDistance )
-				realX = - margins[3];
-			else if ( partName.search( 'l' ) != -1 && abstractDialogCoords.x2 - abstractDialogCoords.x < minWidth + magnetDistance )
-				realX = abstractDialogCoords.x2 - minWidth;
-			else
-				realX = abstractDialogCoords.x;
-
-			if ( abstractDialogCoords.y + margins[0] < magnetDistance )
-				realY = - margins[0];
-			else if ( partName.search( 't' ) != -1 && abstractDialogCoords.y2 - abstractDialogCoords.y < minHeight + magnetDistance )
-				realY = abstractDialogCoords.y2 - minHeight;
-			else
-				realY = abstractDialogCoords.y;
-
-			if ( abstractDialogCoords.x2 - margins[1] > viewPaneSize.width - magnetDistance )
-				realX2 = viewPaneSize.width + margins[1] ;
-			else if ( partName.search( 'r' ) != -1 && abstractDialogCoords.x2 - abstractDialogCoords.x < minWidth + magnetDistance )
-				realX2 = abstractDialogCoords.x + minWidth;
-			else
-				realX2 = abstractDialogCoords.x2;
-
-			if ( abstractDialogCoords.y2 - margins[2] > viewPaneSize.height - magnetDistance )
-				realY2= viewPaneSize.height + margins[2] ;
-			else if ( partName.search( 'b' ) != -1 && abstractDialogCoords.y2 - abstractDialogCoords.y < minHeight + magnetDistance )
-				realY2 = abstractDialogCoords.y + minHeight;
-			else
-				realY2 = abstractDialogCoords.y2 ;
-
-			dialog.move( realX, realY );
-			dialog.resize( realX2 - realX, realY2 - realY );
-
-			evt.data.preventDefault();
-		}
-
-		function mouseUpHandler( evt )
+		function mouseUpHandler()
 		{
 			CKEDITOR.document.removeListener( 'mouseup', mouseUpHandler );
@@ -1788,21 +1810,23 @@
 				coverDoc.removeListener( 'mousemove', mouseMoveHandler );
 			}
-		}
-
-// TODO : Simplify the resize logic, having just a single resize grip <div>.
-//		var widthTest = /[lr]/,
-//			heightTest = /[tb]/;
-//		for ( var i = 0 ; i < parts.length ; i++ )
-//		{
-//			var element = dialog.parts[ parts[i] + '_resize' ];
-//			if ( resizable == CKEDITOR.DIALOG_RESIZE_NONE ||
-//					resizable == CKEDITOR.DIALOG_RESIZE_HEIGHT && widthTest.test( parts[i] ) ||
-//			  		resizable == CKEDITOR.DIALOG_RESIZE_WIDTH && heightTest.test( parts[i] ) )
-//			{
-//				element.hide();
-//				continue;
-//			}
-//			element.on( 'mousedown', mouseDownHandler, dialog, { part : parts[i] } );
-//		}
+
+			// Switch back to use the left property, if RTL is used.
+			if ( editor.lang.dir == 'rtl' )
+			{
+				var element = dialog._.element.getFirst(),
+					left = element.getComputedStyle( 'left' );
+
+				// IE might return "auto", we need exact position.
+				if ( left == 'auto' )
+					left = viewSize.width - parseInt( element.getStyle( 'right' ), 10 ) - dialog.getSize().width;
+				else
+					left = parseInt( left, 10 );
+
+				element.removeStyle( 'right' );
+				// Make sure the left property gets applied, even if it is the same as previously.
+				dialog._.position.x += 1;
+				dialog.move( left, dialog._.position.y );
+			}
+		}
 	}
 
@@ -2993,4 +3017,32 @@
 
 /**
+ * The guildeline to follow when generating the dialog buttons. There are 3 possible options:
+ * <ul>
+ *     <li>'OS' - the buttons will be displayed in the default order of the user's OS;</li>
+ *     <li>'ltr' - for Left-To-Right order;</li>
+ *     <li>'rtl' - for Right-To-Left order.</li>
+ * </ul>
+ * @name CKEDITOR.config.dialog_buttonsOrder
+ * @type String
+ * @default 'OS'
+ * @since 3.5
+ * @example
+ * config.dialog_buttonsOrder = 'rtl';
+ */
+
+/**
+ * The dialog contents to removed. It's a string composed by dialog name and tab name with a colon between them.
+ * Separate each pair with semicolon (see example).
+ * <b>Note: All names are case-sensitive.</b>
+ * <b>Note: Be cautious when specifying dialog tabs that are mandatory, like "info", dialog functionality might be broken because of this!<b>
+ * @name CKEDITOR.config.removeDialogTabs
+ * @type String
+ * @since 3.5
+ * @default ''
+ * @example
+ * config.removeDialogTabs = 'flash:advanced;image:Link';
+ */
+
+/**
  * Fired when a dialog definition is about to be used to create a dialog into
  * an editor instance. This event makes it possible to customize the definition
Index: CKEditor/trunk/_source/plugins/dialogui/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/dialogui/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/dialogui/plugin.js	(revision 6241)
@@ -1461,5 +1461,5 @@
 				getValue : function()
 				{
-					return this.getInputElement().$.value;
+					return this.getInputElement().$.value || '';
 				},
 
Index: CKEditor/trunk/_source/plugins/div/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/div/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/div/plugin.js	(revision 6241)
@@ -38,8 +38,8 @@
 								div = blockLimit.is( 'div' ) && blockLimit;
 
-							if ( div && !div.getAttribute( '_cke_div_added' ) )
+							if ( div && !div.data( 'cke-div-added' ) )
 							{
 								toRemove.push( div );
-								div.setAttribute( '_cke_div_added' );
+								div.data( 'cke-div-added' );
 							}
 						}
Index: CKEditor/trunk/_source/plugins/elementspath/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/elementspath/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/elementspath/plugin.js	(revision 6241)
@@ -20,6 +20,7 @@
 				var element = CKEDITOR.document.getById( idBase + '0' );
 
-				if ( element )
-					element.focus();
+				// Make the first button focus accessible for IE. (#3417)
+				// Adobe AIR instead need while of delay.
+				element && element.focus( CKEDITOR.env.ie || CKEDITOR.env.air );
 			}
 		}
@@ -55,4 +56,58 @@
 							'<div id="' + spaceId + '" class="cke_path" role="group" aria-labelledby="' + spaceId + '_label">' + emptyHtml + '</div>';
 					}
+				});
+
+			function onClick( elementIndex )
+			{
+				editor.focus();
+				var element = editor._.elementsPath.list[ elementIndex ];
+				if ( element.is( 'body' ) )
+				{
+					var range = new CKEDITOR.dom.range( editor.document );
+					range.selectNodeContents( element );
+					range.select();
+				}
+				else
+					editor.getSelection().selectElement( element );
+			}
+
+			var onClickHanlder = CKEDITOR.tools.addFunction( onClick );
+
+			var onKeyDownHandler = CKEDITOR.tools.addFunction( function( elementIndex, ev )
+				{
+					var idBase = editor._.elementsPath.idBase,
+						element;
+
+					ev = new CKEDITOR.dom.event( ev );
+
+					var rtl = editor.lang.dir == 'rtl';
+					switch ( ev.getKeystroke() )
+					{
+						case rtl ? 39 : 37 :		// LEFT-ARROW
+						case 9 :					// TAB
+							element = CKEDITOR.document.getById( idBase + ( elementIndex + 1 ) );
+							if ( !element )
+								element = CKEDITOR.document.getById( idBase + '0' );
+							element.focus();
+							return false;
+
+						case rtl ? 37 : 39 :		// RIGHT-ARROW
+						case CKEDITOR.SHIFT + 9 :	// SHIFT + TAB
+							element = CKEDITOR.document.getById( idBase + ( elementIndex - 1 ) );
+							if ( !element )
+								element = CKEDITOR.document.getById( idBase + ( editor._.elementsPath.list.length - 1 ) );
+							element.focus();
+							return false;
+
+						case 27 :					// ESC
+							editor.focus();
+							return false;
+
+						case 13 :					// ENTER	// Opera
+						case 32 :					// SPACE
+							onClick( elementIndex );
+							return false;
+					}
+					return true;
 				});
 
@@ -83,6 +138,6 @@
 							var index = elementsList.push( element ) - 1;
 							var name;
-							if ( element.getAttribute( '_cke_real_element_type' ) )
-								name = element.getAttribute( '_cke_real_element_type' );
+							if ( element.data( 'cke-real-element-type' ) )
+								name = element.data( 'cke-real-element-type' );
 							else
 								name = element.getName();
@@ -113,7 +168,7 @@
 									' onfocus="event.preventBubble();"' : '' ) +
 									' hidefocus="true" ' +
-									' onkeydown="return CKEDITOR._.elementsPath.keydown(\'', editor.name, '\',', index, ', event);"' +
+									' onkeydown="return CKEDITOR.tools.callFunction(', onKeyDownHandler, ',', index, ', event );"' +
 									extra ,
-									' onclick="return CKEDITOR._.elementsPath.click(\'', editor.name, '\',', index, ');"',
+									' onclick="CKEDITOR.tools.callFunction('+ onClickHanlder, ',', index, '); return false;"',
 									' role="button" aria-labelledby="' + idBase + index + '_label">',
 										name,
@@ -129,5 +184,7 @@
 					}
 
-					getSpaceElement().setHtml( html.join('') + emptyHtml );
+					var space = getSpaceElement();
+					space.setHtml( html.join('') + emptyHtml );
+					editor.fire( 'elementsPathUpdate', { space : space } );
 				});
 
@@ -143,72 +200,2 @@
 	});
 })();
-
-/**
- * Handles the click on an element in the element path.
- * @private
- */
-CKEDITOR._.elementsPath =
-{
-	click : function( instanceName, elementIndex )
-	{
-		var editor = CKEDITOR.instances[ instanceName ];
-		editor.focus();
-
-		var element = editor._.elementsPath.list[ elementIndex ];
-
-		if ( element.is( 'body' ) )
-		{
-			var range = new CKEDITOR.dom.range( editor.document );
-			range.selectNodeContents( element );
-			range.select();
-		}
-		else
-			editor.getSelection().selectElement( element );
-
-		return false;
-	},
-
-	keydown : function( instanceName, elementIndex, ev )
-	{
-		var instance = CKEDITOR.ui.button._.instances[ elementIndex ];
-		var editor = CKEDITOR.instances[ instanceName ];
-		var idBase = editor._.elementsPath.idBase;
-
-		var element;
-
-		ev = new CKEDITOR.dom.event( ev );
-
-		var rtl = editor.lang.dir == 'rtl';
-		switch ( ev.getKeystroke() )
-		{
-			case rtl ? 39 : 37 :					// LEFT-ARROW
-			case 9 :					// TAB
-				element = CKEDITOR.document.getById( idBase + ( elementIndex + 1 ) );
-				if ( !element )
-					element = CKEDITOR.document.getById( idBase + '0' );
-				element.focus();
-				return false;
-
-			case rtl ? 37 : 39 :					// RIGHT-ARROW
-			case CKEDITOR.SHIFT + 9 :	// SHIFT + TAB
-				element = CKEDITOR.document.getById( idBase + ( elementIndex - 1 ) );
-				if ( !element )
-					element = CKEDITOR.document.getById( idBase + ( editor._.elementsPath.list.length - 1 ) );
-				element.focus();
-				return false;
-
-			case 27 :					// ESC
-				editor.focus();
-				return false;
-
-			case 13 :					// ENTER	// Opera
-			case 32 :					// SPACE
-				this.click( instanceName, elementIndex );
-				return false;
-
-			//default :
-			//	alert( ev.getKeystroke() );
-		}
-		return true;
-	}
-};
Index: CKEditor/trunk/_source/plugins/enterkey/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/enterkey/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/enterkey/plugin.js	(revision 6241)
@@ -231,5 +231,5 @@
 					newBlockDir;
 
-				if ( newBlockDir = startBlock.getDirection() )
+				if ( ( newBlockDir = startBlock.getDirection() ) )
 				{
 					newBlock = doc.createElement( 'div' );
Index: CKEditor/trunk/_source/plugins/fakeobjects/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/fakeobjects/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/fakeobjects/plugin.js	(revision 6241)
@@ -13,5 +13,5 @@
 			{
 				var attributes = element.attributes,
-					realHtml = attributes && attributes._cke_realelement,
+					realHtml = attributes && attributes[ 'data-cke-realelement' ],
 					realFragment = realHtml && new CKEDITOR.htmlParser.fragment.fromHtml( decodeURIComponent( realHtml ) ),
 					realElement = realFragment && realFragment.children[ 0 ];
@@ -19,5 +19,5 @@
 				// If we have width/height in the element, we must move it into
 				// the real element.
-				if ( realElement && element.attributes._cke_resizable )
+				if ( realElement && element.attributes[ 'data-cke-resizable' ] )
 				{
 					var style = element.attributes.style;
@@ -63,5 +63,6 @@
 CKEDITOR.editor.prototype.createFakeElement = function( realElement, className, realElementType, isResizable )
 {
-	var lang = this.lang.fakeobjects;
+	var lang = this.lang.fakeobjects,
+		label = lang[ realElementType ] || lang.unknown;
 
 	var attributes =
@@ -69,15 +70,16 @@
 		'class' : className,
 		src : CKEDITOR.getUrl( 'images/spacer.gif' ),
-		_cke_realelement : encodeURIComponent( realElement.getOuterHtml() ),
-		_cke_real_node_type : realElement.type,
-		alt : lang[ realElementType ] || lang.unknown,
+		'data-cke-realelement' : encodeURIComponent( realElement.getOuterHtml() ),
+		'data-cke-real-node-type' : realElement.type,
+		alt : label,
+		title : label,
 		align : realElement.getAttribute( 'align' ) || ''
 	};
 
 	if ( realElementType )
-		attributes._cke_real_element_type = realElementType;
+		attributes[ 'data-cke-real-element-type' ] = realElementType;
 
 	if ( isResizable )
-		attributes._cke_resizable = isResizable;
+		attributes[ 'data-cke-resizable' ] = isResizable;
 
 	return this.document.createElement( 'img', { attributes : attributes } );
@@ -87,4 +89,5 @@
 {
 	var lang = this.lang.fakeobjects,
+		label = lang[ realElementType ] || lang.unknown,
 		html;
 
@@ -97,15 +100,16 @@
 		'class' : className,
 		src : CKEDITOR.getUrl( 'images/spacer.gif' ),
-		_cke_realelement : encodeURIComponent( html ),
-		_cke_real_node_type : realElement.type,
-		alt : lang[ realElementType ] || lang.unknown,
+		'data-cke-realelement' : encodeURIComponent( html ),
+		'data-cke-real-node-type' : realElement.type,
+		alt : label,
+		title : label,
 		align : realElement.attributes.align || ''
 	};
 
 	if ( realElementType )
-		attributes._cke_real_element_type = realElementType;
+		attributes[ 'data-cke-real-element-type' ] = realElementType;
 
 	if ( isResizable )
-		attributes._cke_resizable = isResizable;
+		attributes[ 'data-cke-resizable' ] = isResizable;
 
 	return new CKEDITOR.htmlParser.element( 'img', attributes );
@@ -114,9 +118,9 @@
 CKEDITOR.editor.prototype.restoreRealElement = function( fakeElement )
 {
-	if ( fakeElement.getAttribute( '_cke_real_node_type' ) != CKEDITOR.NODE_ELEMENT )
+	if ( fakeElement.data( 'cke-real-node-type' ) != CKEDITOR.NODE_ELEMENT )
 		return null;
 
 	return CKEDITOR.dom.element.createFromHtml(
-		decodeURIComponent( fakeElement.getAttribute( '_cke_realelement' ) ),
+		decodeURIComponent( fakeElement.data( 'cke-realelement' ) ),
 		this.document );
 };
Index: CKEditor/trunk/_source/plugins/filebrowser/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/filebrowser/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/filebrowser/plugin.js	(revision 6241)
@@ -279,5 +279,5 @@
 			else if ( element.filebrowser.action == 'QuickUpload' && element[ 'for' ] )
 			{
-				var url = element.filebrowser.url;
+				url = element.filebrowser.url;
 				if ( url === undefined )
 				{
Index: CKEditor/trunk/_source/plugins/flash/dialogs/flash.js
===================================================================
--- CKEditor/trunk/_source/plugins/flash/dialogs/flash.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/flash/dialogs/flash.js	(revision 6241)
@@ -191,5 +191,5 @@
 				// Try to detect any embed or object tag that has Flash parameters.
 				var fakeImage = this.getSelectedElement();
-				if ( fakeImage && fakeImage.getAttribute( '_cke_real_element_type' ) && fakeImage.getAttribute( '_cke_real_element_type' ) == 'flash' )
+				if ( fakeImage && fakeImage.data( 'cke-real-element-type' ) && fakeImage.data( 'cke-real-element-type' ) == 'flash' )
 				{
 					this.fakeImage = fakeImage;
@@ -366,6 +366,6 @@
 									id : 'width',
 									style : 'width:95px',
-									label : editor.lang.flash.width,
-									validate : CKEDITOR.dialog.validate.integer( editor.lang.flash.validateWidth ),
+									label : editor.lang.common.width,
+									validate : CKEDITOR.dialog.validate.integer( editor.lang.common.invalidWidth ),
 									setup : function( objectNode, embedNode, paramMap, fakeImage )
 									{
@@ -389,6 +389,6 @@
 									id : 'height',
 									style : 'width:95px',
-									label : editor.lang.flash.height,
-									validate : CKEDITOR.dialog.validate.integer( editor.lang.flash.validateHeight ),
+									label : editor.lang.common.height,
+									validate : CKEDITOR.dialog.validate.integer( editor.lang.common.invalidHeight ),
 									setup : function( objectNode, embedNode, paramMap, fakeImage )
 									{
@@ -559,5 +559,5 @@
 									id : 'align',
 									type : 'select',
-									label : editor.lang.flash.align,
+									label : editor.lang.common.align,
 									'default' : '',
 									style : 'width : 100%;',
@@ -565,13 +565,13 @@
 									[
 										[ editor.lang.common.notSet , ''],
-										[ editor.lang.flash.alignLeft , 'left'],
+										[ editor.lang.common.alignLeft , 'left'],
 										[ editor.lang.flash.alignAbsBottom , 'absBottom'],
 										[ editor.lang.flash.alignAbsMiddle , 'absMiddle'],
 										[ editor.lang.flash.alignBaseline , 'baseline'],
-										[ editor.lang.flash.alignBottom , 'bottom'],
-										[ editor.lang.flash.alignMiddle , 'middle'],
-										[ editor.lang.flash.alignRight , 'right'],
+										[ editor.lang.common.alignBottom , 'bottom'],
+										[ editor.lang.common.alignMiddle , 'middle'],
+										[ editor.lang.common.alignRight , 'right'],
 										[ editor.lang.flash.alignTextTop , 'textTop'],
-										[ editor.lang.flash.alignTop , 'top']
+										[ editor.lang.common.alignTop , 'top']
 									],
 									setup : loadValue,
Index: CKEditor/trunk/_source/plugins/flash/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/flash/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/flash/plugin.js	(revision 6241)
@@ -76,5 +76,5 @@
 					var element = evt.data.element;
 
-					if ( element.is( 'img' ) && element.getAttribute( '_cke_real_element_type' ) == 'flash' )
+					if ( element.is( 'img' ) && element.data( 'cke-real-element-type' ) == 'flash' )
 						evt.data.dialog = 'flash';
 				});
@@ -86,5 +86,5 @@
 					{
 						if ( element && element.is( 'img' ) && !element.isReadOnly()
-								&& element.getAttribute( '_cke_real_element_type' ) == 'flash' )
+								&& element.data( 'cke-real-element-type' ) == 'flash' )
 							return { flash : CKEDITOR.TRISTATE_OFF };
 					});
Index: CKEditor/trunk/_source/plugins/floatpanel/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/floatpanel/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/floatpanel/plugin.js	(revision 6241)
@@ -306,5 +306,5 @@
 							this.allowBlur( true );
 						}, 0, this);
-					}, 0, this);
+					},  CKEDITOR.env.air ? 200 : 0, this);
 				this.visible = 1;
 
